/***
 * Excerpted from "Domain-Driven Design Using Naked Objects",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/dhnako for more book information.
***/
public void payUsing(final PaymentMethod paymentMethod) {
    paymentMethod.pay(this);
}
public String validatePayUsing(PaymentMethod paymentMethod) {
    final ReasonBuffer buf = new ReasonBuffer();

    buf.appendOnCondition(
        paymentMethod.getOwner() != 
                          getVehicle().getOwningCustomer(), 
        "Payment method must belong to this customer");
    
    buf.appendOnCondition(
        !paymentMethod.getCurrent(), 
        "Payment method must be current");

    buf.append(paymentMethod.validatePay(this));
    return buf.getReason();
}
public List<PaymentMethod> choices0PayUsing() {
    return getVehicle().getOwningCustomer().getPaymentMethods();
}
public String disablePayUsing() {
    final ReasonBuffer buf = new ReasonBuffer();
    buf.appendOnCondition(getAmount() == 0, "Nothing to pay");
    buf.appendOnCondition(getPaid(), "Already paid");
    return buf.getReason();
}
